/* IChemCastObject.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.similarity.data;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public interface IChemCastObject {

    public static String p_properties = "properties";
    public static String p_name = "name";
    public static String p_tag="tag";
    public static String p_value="value";
    public static String p_class="classname";
    public static String p_parameters = "parameters";
    public static String p_parameter = "parameter";
    public abstract PropertyChangeSupport getPropertyChangeSupport();

    public abstract void setPropertyChangeSupport(
            PropertyChangeSupport propertyChangeSupport);

    public abstract Element getXMLElement(Document document);

    public abstract void setXMLElement(Element element) throws Exception;

    public abstract void firePropertyChange(String propertyName,
            Object oldValue, Object newValue);
    public abstract void firePropertyChange(PropertyChangeEvent event);

    public abstract void addPropertyChangeListener(String propertyName,
            PropertyChangeListener listener);

    public abstract void addPropertyChangeListener(
            PropertyChangeListener listener);

    public abstract void removePropertyChangeListener(
            PropertyChangeListener listener);

    public abstract void removePropertyChangeListener(String propertyName,
            PropertyChangeListener listener);
    public abstract boolean isEnabled();
    
    public abstract void setEnabled(boolean enabled);
}