/* NN_MCSSSimilarity.java
 * Author: Nina Jeliazkova
 * Date: Feb 4, 2007 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.similarity.data;

import org.openscience.cdk.interfaces.IAtomContainer;

import ambit.data.molecule.IAtomContainersList;
import ambit.exceptions.AmbitException;
import ambit.similarity.MCSSDistance;

public class NN_MCSSSimilarity extends NearestNeighborsSimilaritySubsets<IAtomContainer> {

    /**
     * 
     */
    private static final long serialVersionUID = -3656571129019954210L;

    public NN_MCSSSimilarity(int knn) {
        super(new MCSSDistance(), knn);
        getNearestNeighborsSearch().setLowestDistanceIsClosest(false);
    }
    public NN_MCSSSimilarity() {
        this(5);
    }

    @Override
    protected IAtomContainer readComparableProperty(IAtomContainersList list, int index)
            throws AmbitException {
        return list.getAtomContainer(index);
    }
    

    @Override
    protected IAtomContainer calculateComparableProperty(Object object) throws AmbitException {
        return (IAtomContainer) object;
    }

    @Override
    protected void writeComparableProperty(IAtomContainersList list, int index, IAtomContainer property) throws AmbitException {

        
    }
	@Override
	protected int getNumberOfAttributes() {
		return 0;
	}
	@Override
	protected Object readAttribute(IAtomContainer attributes, int attribute_index) {
		return null;
	}
	@Override
	protected double readMaxAttribute(int attribute_index) {
		return 1;
	}
	@Override
	protected double readMinAttribute(int attribute_index) {
		return 0;
	}
	@Override
	protected IAtomContainer getSelectedAttributes(IAtomContainer attributes) {
		return attributes;
	}
    
}
