package chemCast.ui;

import hypergraph.graph.GraphEventImpl;
import hypergraph.graphApi.Edge;
import hypergraph.graphApi.Graph;
import hypergraph.graphApi.GraphException;
import hypergraph.graphApi.GraphSystem;
import hypergraph.graphApi.GraphSystemFactory;
import hypergraph.graphApi.Node;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Vector;

import ambit.processors.results.AbstractSimilarityMatrix;
import ambit.ui.GraphPanel;

public class HyperGraphSimilarityPanel extends GraphPanel implements PropertyChangeListener {
	protected float threshold = 0.8f;
	protected Vector<Graph> graphs;
	/**
	 * 
	 */
	private static final long serialVersionUID = -6064355665219283573L;

	public HyperGraphSimilarityPanel() {
		super(createGraph());

	}
	public static Graph createGraph() {
		try {
		GraphSystem graphSystem = GraphSystemFactory.createGraphSystem("hypergraph.graph.GraphSystemImpl", null);
		return graphSystem.createGraph();
		} catch (GraphException x) {
			return null;
		}
	}
	public void propertyChange(PropertyChangeEvent e) {
		Object result = e.getNewValue();
    	if (result instanceof AbstractSimilarityMatrix) {
    		setMatrix((AbstractSimilarityMatrix) result);
    	}
	}

	public void setMatrix(AbstractSimilarityMatrix matrix) {
		Graph graph = getGraph();
		getGraph().removeAll();
		graph.elementsRemoved(new GraphEventImpl(graph));
		//Graph graph = createGraph();
		
		try {
			/*
			Node parentNode = graph.createNode("All");
			Node parentNode5 = graph.createNode("0.5");
			Node parentNode6 = graph.createNode("0.6");
			Node parentNode7 = graph.createNode("0.7");
			Node parentNode8 = graph.createNode("0.8");
			Node parentNode9 = graph.createNode("0.9");
			Node parentNode10 = graph.createNode("1");
			graph.createEdge(parentNode5,parentNode);
			graph.createEdge(parentNode6,parentNode);
			graph.createEdge(parentNode7,parentNode);
			graph.createEdge(parentNode8,parentNode);
			graph.createEdge(parentNode9,parentNode);
			graph.createEdge(parentNode10,parentNode);
			*/
			/*
			Group g8 = graph.createGroup("0.8");
			Group g9 = graph.createGroup("0.9");
			Group g10 = graph.createGroup("1.0");
			*/
			for (int r=0; r < matrix.getRowCount();r++) 
				for (int c=0; c < r; c++) {
					Float f = (Float)matrix.getValueAt(r,c);
					if (f.floatValue()>threshold) {
						String rowId = "Row"+Integer.toString(r);
						Node rowNode = (Node)graph.getElement(rowId);
						if (rowNode==null) {
							rowNode = graph.createNode(rowId);
							graph.addElement(rowNode);
							
				/*			
							parentNode = null;
							if (f.floatValue()<0.6) parentNode = parentNode5;
							else if (f.floatValue()<0.7) parentNode = parentNode6;
							else if (f.floatValue()<0.8) parentNode = parentNode7;
							else if (f.floatValue()<0.9) parentNode = parentNode8;
							else if (f.floatValue()<1) parentNode = parentNode9;
							else parentNode = parentNode10;
							
							graph.createEdge(rowNode,parentNode);
*/
						}
						String colId = "Row"+Integer.toString(c);
						Node colNode = (Node)graph.getElement(colId);
						if (colNode==null) {
							colNode = graph.createNode(colId);
							graph.addElement(colNode);
							//graph.createEdge(colNode,parentNode);
						}
						System.out.println(rowNode.getName() + "," + colNode.getName() + "=" + f.toString());
						
						Edge edge = graph.createEdge(rowNode,colNode);
						/*
						if (f.floatValue()<0.9) edge.setGroup(g8);  
						else if (f.floatValue()<1) edge.setGroup(g9);
							else edge.setGroup(g10);
*/
						
						
					}
				}
			
			
			//graph.notifyAll();
			System.out.println("Graph " + graph.getNodes().size());
		} catch (GraphException x) {
			x.printStackTrace();
		}
		
	}
	


}
