/* ListsPanel.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.ui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.util.List;

import javax.swing.AbstractListModel;
import javax.swing.JScrollPane;

import chemCast.similarity.data.IChemCastList;

public class ListsPanel extends ListPanel {
    /**
     * 
     */
    private static final long serialVersionUID = -8504277092578163343L;
    List<? extends IChemCastList> lists;
    //JList box;
    RadioBoxPanel radioBox;
    public ListsPanel(String caption,List<? extends IChemCastList> lists) {
        super(caption,lists.get(0));
        radioBox = new RadioBoxPanel("Groups",lists,0){
            @Override
            public void selectObject(ActionEvent e, Object object) {
                if (object instanceof IChemCastList) {
                    setList(getCaption(),(IChemCastList)object);
                    //
                }
            }
        };
        /*
        box = new JList(new ListsComboBoxModel(lists));
        //JList box = new JList(new String[] {"ccc","xxx"});

        box.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                if (e.getValueIsAdjusting()) return;
                JList options = (JList)e.getSource();
                Object[] selected = options.getSelectedValues();
                
                // 
                for (int i=0; i<selected.length; i++) 
                    if (selected[i] != null) {
                        setList(getCaption(),(IChemCastList)selected[i]);
                        break;
                    }

                
            }
         
        });
        box.setSelectedIndex(0);
        JScrollPane p = new JScrollPane(box);
        */
        JScrollPane p = new JScrollPane(radioBox);
        //p.setPreferredSize(new Dimension(100,50));
        //p.setMinimumSize(new Dimension(100,32));
        add(p,BorderLayout.NORTH);
    }
    public synchronized List<? extends IChemCastList> getLists() {
        return lists;
    }
    public synchronized void setLists(List<? extends IChemCastList> lists) {
        this.lists = lists;
        radioBox.setOptions(lists,0);
        setList(getCaption(),lists.get(0));
    }
    public int getSelectedIndex() {
        return radioBox.getSelectedIndex();
    }
    public Object getSelectedItem() {
        return lists.get(getSelectedIndex());
    }
    /*
    public synchronized void setLists(List<? extends IChemCastList> lists) {
        this.lists = lists;
        ((ListsComboBoxModel)box.getModel()).setLists(lists);
        box.setSelectedIndex(0);
        setList(getCaption(),lists.get(0));
    }
    */
    
}

class ListsComboBoxModel extends AbstractListModel {
    /**
     * 
     */
    private static final long serialVersionUID = 3057205330941240055L;
    protected  List<? extends IChemCastList> lists;

    public ListsComboBoxModel(List<? extends IChemCastList> lists) {
        super();
        this.lists = lists;
        
    }
    public int getSize() {
        return lists.size();
    }
 
    public Object getElementAt(int index) {
        
        return lists.get(index);
    }
    public synchronized List<? extends IChemCastList> getLists() {
        return lists;
    }
    public synchronized void setLists(List<? extends IChemCastList> lists) {
        this.lists = lists;
        fireContentsChanged(this, -1,-1);
    }

    
}
