/* SubsetsAction.java
 * Author: Nina Jeliazkova
 * Date: Oct 1, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.ui.actions;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import ambit.ui.UITools;
import chemCast.application.ChemCASTModule;
import chemCast.exception.SubsetException;
import chemCast.similarity.data.Subsets;
import chemCast.ui.ListsPanel;

public class SubsetsAction extends ToxmatchAction {

    /**
     * 
     */
    private static final long serialVersionUID = 282332603793129112L;

    public SubsetsAction(ChemCASTModule userData, JFrame mainFrame, int dataset) {
        this(userData, mainFrame,"Subsets", dataset);
    }

    public SubsetsAction(ChemCASTModule userData, JFrame mainFrame,
            String name, int dataset) {
        this(userData, mainFrame, name, UITools.createImageIcon("ambit/ui/images/dataset.png"), dataset);

    }

    public SubsetsAction(ChemCASTModule userData, JFrame mainFrame,
            String name, Icon icon, int dataset) {
        super(userData, mainFrame, name, icon, dataset);
    }   

    @Override
    protected void processDataset(Subsets data) throws Exception {
    	if (getChemCastData().getEndpoint() != null) {
	    	ListsPanel subsetsPanel = new ListsPanel("Select data subsets",getChemCastData().getEndpoint().getSubsets());
	    	if (JOptionPane.showConfirmDialog(mainFrame,subsetsPanel,"",JOptionPane.OK_CANCEL_OPTION,JOptionPane.PLAIN_MESSAGE) == JOptionPane.OK_OPTION) {
	    		Subsets subsets = getChemCastData().getEndpoint().getSubsets().get(
	    				subsetsPanel.getSelectedIndex());
	    		if (subsets != null) {
	    			//getChemCastData().setSubsets(subsets);
                    try {
                        data.updateSubsets(subsets);
                        } catch (SubsetException x) {
                            JOptionPane.showMessageDialog(mainFrame,x.toString(),"Error",JOptionPane.ERROR_MESSAGE);
                        }
                    
	    			
	    			
	    			
	    		}
	    			
	    			
	    	}
    	}
    }
}
