/* ChemCastWizardPanelDescriptor.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.ui.wizard;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import ambit.ui.UITools;

import com.nexes.wizard.WizardPanelDescriptor;

public class ChemCastWizardPanelDescriptor extends WizardPanelDescriptor {
    protected Object id;
    protected Object backId;
    protected Object nextId;
    
    public ChemCastWizardPanelDescriptor(Object id, Object nextId, Object backId, JComponent panel, ImageIcon icon) {
        super(id,new LogoPanel(panel,icon));
        this.id = id;
        this.nextId = nextId;
        this.backId = backId;
           
    }
    
    public Object getNextPanelDescriptor() {
        return nextId;
    }
    
    public Object getBackPanelDescriptor() {
        return backId;
    }

    public synchronized Object getBackId() {
        return backId;
    }

    public synchronized void setBackId(Object backId) {
        this.backId = backId;
    }

    public synchronized Object getNextId() {
        return nextId;
    }

    public synchronized void setNextId(Object nextId) {
        this.nextId = nextId;
    }

    public synchronized Object getId() {
        return id;
    }

    public synchronized void setId(Object id) {
        this.id = id;
    }  

}

class LogoPanel extends JPanel {
    public LogoPanel(JComponent component, ImageIcon icon) {
        super();
        
        JLabel iconLabel = new JLabel();
        setLayout(new java.awt.BorderLayout());
        iconLabel.setOpaque(true);
        iconLabel.setBackground(new Color(35,207,213));
        //iconLabel.setBackground(new Color(192,192,192));
        if (icon == null) icon = getImageIcon();
        if (icon != null)
            iconLabel.setIcon(icon);
        
        //iconLabel.setBorder(new EtchedBorder(EtchedBorder.RAISED));
        
        add(iconLabel, BorderLayout.WEST);
        add(component, BorderLayout.CENTER);
        setBorder(null);

    }
    private ImageIcon getImageIcon() {
        return UITools.createImageIcon("ambit/ui/images/wizard.png");//new ImageIcon((URL)getResource("clouds.jpg"));
    }
}
